%x_layers = [1,5,10,20,35]; % Tarbert
x_layers = [1,5,10,20,35,50]; % Upper Ness
%x_layers = [2,7,16,30,85]; % Borderline
numpt = length(x_layers);
x_cells = 220*60*x_layers;
numcom = 9;
numtot = numcom + 1; % adds mldivide

y = zeros(numtot,numpt); % results
p = zeros(numtot,numpt); % polynomial coefficients
pol = zeros(numtot,100); % polynomials evaluated on finer grid 

%% Time (s):

%---------------------------------------------------------------------
% Layers: 35-36, 32-38, 30-45, 21-50, 1-85:

% Borderline 2:
% y(1,:) = [0.13, 1.22, 1.35, 2.88, 3.98];      % BiCGstab + sm. aggr. + SPAI0
% y(2,:) = [0.13, 1.04, 1.28, 2.48, 3.45];      % BiCGstab + sm. aggr. + G-S
% y(3,:) = [0.12, 1.19, 1.39, 2.99, 3.69];      % BiCGstab + sm. aggr. + DJ
% y(4,:) = [0.07, 0.78, 0.96, 2.22, 3.49];      % CG + sm. aggr. + DJ
% y(5,:) = [0.05, 0.34, 0.70, 1.33, 3.98];      % CG + sm. aggr. + ILU(0)
% y(6,:) = [0.10, 1.28, 1.39, 2.91, 3.84];      % BiCGstabl  + sm. aggr. + SPAI0
% y(7,:) = [0.13, 1.07, 1.38, 2.77, 3.60];      % BiCGstabl + sm. aggr. + G-S
% y(8,:) = [0.11, 1.26, 1.39, 3.02, 3.58];      % BiCGstabl + sm. aggr. + DJ
% y(9,:) = [0.54, 3.29, 1.79, 3.68, 4.11];      % GMRES + sm. aggr. + DJ
% y(10,:) = [0.10, 0.94, 1.16, 2.17, 3.47];      % IDR(s) + sm. aggr. + G-S
% y(11,:) = [0.05, 0.33, 1.83, 8.59, 202.66];     % mldivide

% Borderline 1:
% y(1,:) = [0.09, 0.47, 1.16, 2.36, 7.02];      % BiCGstab + sm. aggr. + ILU(0)
% y(2,:) = [0.11, 0.70, 1.80, 3.53, 11.71];      % BiCGstab + sm. aggr. + ILU(l)
% y(3,:) = [0.09, 0.39, 1.43, 1.61, 5.64];      % BiCGstab + aggr. + ILU(l)
% y(4,:) = [0.10, 0.56, 1.30, 2.88, 8.45];      % BiCGstab + R-S + ILU(l)
% y(5,:) = [0.05, 0.33, 0.69, 1.33, 3.97];      % CG + sm. aggr. + ILU(0)
% y(6,:) = [0.07, 0.31, 1.20, 1.57, 5.18];      % CG + aggr. + ILU(l)
% y(7,:) = [0.08, 0.33, 1.29, 1.87, 5.45];      % LGMRES + aggr. + ILU(l)
% y(8,:) = [0.09, 0.53, 1.18, 3.26, 8.21];      % LGMRES + R-S + ILU(l)
% y(9,:) = [0.10, 0.64, 1.77, 3.63, 11.56];      % FGMRES + sm. aggr. + ILU(l)
% y(10,:) = [0.05, 0.33, 1.83, 8.59, 202.66];     % mldivide


%---------------------------------------------------------------------
% Layers: 45, 41-45, 41-50, 36-55, 41-75, 36-85:

% Ness 2:
% y(1,:) = [0.16, 0.57, 0.42, 1.50, 1.61, 1.63];      % BiCGstab + sm. aggr. + SPAI0
% y(2,:) = [0.11, 0.59, 0.46, 1.92, 1.61, 1.74];     % BiCGstabl + sm. aggr. + DJ
% y(3,:) = [0.12, 0.51, 0.34, 2.00, 1.56, 1.70];      % BiCGstabl + sm. aggr. + G-S
% y(4,:) = [0.06, 0.29, 0.55, 0.91, 1.46, 2.32];      % BiCGstabl + R-S + ILU(0)
% y(5,:) = [2.24, 1.28, 0.55, 2.71, 1.84, 1.77];      % GMRES + sm. aggr. + DJ
% y(6,:) = [3.43, 0.25, 0.34, 0.86, 1.42, 2.28];      % LGMRES + sm. aggr. + ILU(0)
% y(7,:) = [2.22, 1.14, 0.46, 2.29, 1.69, 1.71];     % FGMRES + sm. aggr. + SPAI0
% y(8,:) = [0.10, 0.50, 0.45, 1.58, 1.81, 1.74];      % IDR(s) + sm. aggr. + DJ
% y(9,:) = [0.10, 0.44, 0.45, 1.47, 1.52, 1.67];      % IDR(s) + sm. aggr. + G-S
% y(10,:) = [0.10, 0.52, 0.44, 1.58, 1.58, 1.74];      % IDR(s) + sm. aggr. + SPAI0
% y(11,:) = [0.01, 0.18, 0.66, 2.46, 9.82, 24.42];     % mldivide

% Ness 1:
y(1,:) = [0.24, 0.57, 0.42, 1.54, 1.60, 1.62];      % BiCGstab + sm. aggr. + SPAI0
y(2,:) = [0.12, 0.51, 0.42, 1.88, 1.48, 1.54];      % BiCGstab + sm. aggr. + G-S
y(3,:) = [0.03, 0.22, 0.34, 0.96, 1.29, 2.47];      % CG + sm. aggr. + ILU(0)
y(4,:) = [0.05, 0.28, 0.42, 1.14, 1.52, 3.14];      % BiCGstabl + sm. aggr. + ILU(0)
y(5,:) = [0.13, 0.52, 0.44, 1.98, 1.56, 1.70];      % BiCGstabl + sm. aggr. + G-S
y(6,:) = [0.04, 0.31, 0.62, 1.39, 2.63, 3.50];      % BiCGstabl + R-S + ILU(l)
y(7,:) = [0.12, 0.24, 0.35, 0.85, 1.42, 2.23];      % GMRES + sm. aggr. + ILU(0)
y(8,:) = [0.12, 0.24, 0.34, 0.87, 1.39, 2.20];      % FGMRES + sm. aggr. + ILU(0)
y(9,:) = [0.04, 0.27, 0.36, 1.12, 1.37, 2.49];      % IDR(s) + sm. aggr. + ILU(0)
y(10,:) = [0.01, 0.18, 0.66, 2.46, 9.82, 24.42];     % mldivide


%---------------------------------------------------------------------
% Layers: 1, 1-5, 1-10, 1-20, 1-35:

% Tarbert 2:
% y(1,:) = [0.05, 0.27, 0.44, 1.09, 1.66];      % BiCGstab + R-S + ILU(0)
% y(2,:) = [0.04, 0.46, 0.93, 2.18, 3.79];      % BiCGstab + R-S + ILU(l)
% y(3,:) = [0.04, 0.17, 0.39, 0.57, 1.05];      % BiCGstab + sm. aggr. + ILU(0)
% y(4,:) = [0.03, 0.15, 0.37, 0.55, 1.05];      % CG + sm. aggr. + ILU(0)
% y(5,:) = [0.04, 0.18, 0.40, 0.71, 1.19];      % BiCGstabl + sm. aggr. + ILU(0)
% y(6,:) = [0.05, 0.15, 0.34, 0.59, 1.10];      % GMRES + sm. aggr. + ILU(0)
% y(7,:) = [3.42, 0.15, 0.35, 0.59, 1.12];      % LGMRES + sm. aggr. + ILU(0)
% y(8,:) = [0.05, 0.15, 0.35, 0.57, 1.08];      % FGMRES + sm. aggr. + ILU(0)
% y(9,:) = [0.03, 0.16, 0.37, 0.60, 1.12];      % IDR(s) + sm. aggr. + ILU(0)
% y(10,:) = [0.01, 0.17, 0.74, 3.20, 13.81];    % mldivide

% Tarbert 1 OLD:
% y(1,:) = [0.05, 0.45, 0.93, 2.22, 3.83];         % BiCGstab + R-S + ILU(l)
% y(2,:) = [0.03, 0.40, 0.95, 2.16, 3.97];         % CG + R-S + ILU(l)
% y(3,:) = [0.06, 10.06, 22.45, 46.26, 81.39];     % BiCGstabl + R-S + ILUT
% y(4,:) = [0.05, 0.46, 0.95, 2.25, 4.13];         % BiCGstabl + R-S + ILU(l)
% y(5,:) = [0.04, 0.44, 0.93, 2.21, 3.94];         % IDR(s) + R-S + ILU(l)
% y(6,:) = [0.01, 0.17, 0.74, 3.20, 13.81];        % mldivide

% Tarbert 1:
% y(1,:) = [0.06, 10.12, 22.43, 45.83, 81.95];     % BiCGstab + R-S + ILUT
% y(2,:) = [0.05, 0.45, 0.91, 2.13, 3.91];         % BiCGstab + R-S + ILU(l)
% y(3,:) = [0.04, 7.99, 18.16, 37.03, 71.69];      % BiCGstabl + sm. aggr. + ILUT
% y(4,:) = [0.06, 9.70, 22.24, 45.63, 82.86];      % BiCGstabl + R-S + ILUT
% y(5,:) = [0.04, 7.91, 18.12, 37.32, 68.38];      % GMRES + sm. aggr. + ILUT
% y(6,:) = [0.01, 0.17, 0.74, 3.20, 13.81];        % mldivide


%% Polynomial regression:

degree = numpt-1;
first = x_cells(1);
last = x_cells(end);
x = linspace(first-3000,last+3000);

for i = 1:(numtot)
    %p(i,:) = polyfit(x_cells,y(i,:),degree); % Not necessary to store these in a matrix. Could just reuse the same variable p.
    pol(i,:) = polyval( polyfit(x_cells,y(i,:),degree),x) ;
end


%% Plotting ln-ln:

figure
hold on

%%%% Solver colors:
% BiCGstab:   [255/255,165/255,0];
% CG:         [124/255,252/255,0];
% BiCGstabl:  [1,0,0];
% GMRES:      [0,191/255,1];
% LGMRES:     [218/255,112/255,214/255];
% FGMRES:     [0,0,205/255];
% IDR(s):     [160/255,82/255,45/255];
%%%%%

% ln-ln plot of polynomials:
plot( log(x),log(pol(1,:)),'color',[255/255,165/255,0] )
plot( log(x),log(pol(2,:)),'--','color',[255/255,165/255,0] )
plot( log(x),log(pol(3,:)),'color',[124/255,252/255,0] )
plot( log(x),log(pol(4,:)),'color',[1,0,0] )
plot( log(x),log(pol(5,:)),'--','color',[1,0,0] )
plot( log(x),log(pol(6,:)),'-.','color',[1,0,0] )
plot( log(x),log(pol(7,:)),'color',[0,191/255,1] )
plot( log(x),log(pol(8,:)),'color',[0,0,205/255] )
plot( log(x),log(pol(9,:)),'color',[160/255,82/255,45/255] )
plot( log(x),log(pol(10,:)),'color','k' )
% plot( log(x),log(pol(11,:)),'k' )

% Result values plotted as points to show if each polynomial is good match
plot( log(x_cells),log(y(1,:)),'o','color',[255/255,165/255,0] )
plot( log(x_cells),log(y(2,:)),'s','color',[255/255,165/255,0] )
plot( log(x_cells),log(y(3,:)),'o','color',[124/255,252/255,0] )
plot( log(x_cells),log(y(4,:)),'o','color',[1,0,0] )
plot( log(x_cells),log(y(5,:)),'s','color',[1,0,0] )
plot( log(x_cells),log(y(6,:)),'d','color',[1,0,0] )
plot( log(x_cells),log(y(7,:)),'o','color',[0,191/255,1] )
plot( log(x_cells),log(y(8,:)),'o','color',[0,0,205/255] )
plot( log(x_cells),log(y(9,:)),'o','color',[160/255,82/255,45/255] )
plot( log(x_cells),log(y(10,:)),'o','color','k' )
%plot( log(x_cells),log(y(11,:)),'o','color','k' )

h = zeros(numtot, 1);
h(1) = plot(NaN,NaN,'o-','color',[255/255,165/255,0]);
h(2) = plot(NaN,NaN,'s--','color',[255/255,165/255,0]);
h(3) = plot(NaN,NaN,'o-','color',[124/255,252/255,0]);
h(4) = plot(NaN,NaN,'o-','color',[1,0,0]);
h(5) = plot(NaN,NaN,'s--','color',[1,0,0]);
h(6) = plot(NaN,NaN,'d-.','color',[1,0,0]);
h(7) = plot(NaN,NaN,'o-','color',[0,191/255,1]);
h(8) = plot(NaN,NaN,'o-','color',[0,0,205/255]);
h(9) = plot(NaN,NaN,'o-','color',[160/255,82/255,45/255]);
h(10) = plot(NaN,NaN,'o-','color','k');
%h(11) = plot(NaN,NaN,'o-','color','k');

xlabel('ln(# grid cells)')
ylabel('ln(time)')

%legend(h, 'BiCGstab + R-S + ILU(l)', 'CG + R-S + ILU(l)', 'BiCGstabl + R-S + ILUT', 'BiCGstabl + R-S + ILU(l)', 'IDR(s) + R-S + ILU(l)', 'mldivide')
legend(h, 'BiCGstab + sm. aggr. + SPAI0', 'BiCGstab + sm. aggr. + G-S', 'CG + sm. aggr. + ILU(0)', 'BiCGstabl + sm. aggr. + ILU(0)', 'BiCGstabl + sm. aggr. + G-S', 'BiCGstabl + R-S + ILU(l)', 'GMRES + sm. aggr. + ILU(0)', 'FGMRES + sm. aggr. + ILU(0)', 'IDR(s) + sm. aggr. + ILU(0)', 'mldivide')


%% Plotting normal:

figure
hold on

% ln-ln plot of polynomials:
plot( x,pol(1,:),'color',[255/255,165/255,0] )
plot( x,pol(2,:),'--','color',[255/255,165/255,0] )
plot( x,pol(3,:),'color',[124/255,252/255,0] )
plot( x,pol(4,:),'color',[1,0,0] )
plot( x,pol(5,:),'--','color',[1,0,0] )
plot( x,pol(6,:),'-.','color',[1,0,0] )
plot( x,pol(7,:),'color',[0,191/255,1] )
plot( x,pol(8,:),'color',[0,0,205/255] )
plot( x,pol(9,:),'color',[160/255,82/255,45/255] )
plot( x,pol(10,:),'color','k' )
%plot( x,pol(11,:),'k' )

% Result values plotted as points to show if each polynomial is good match
plot( x_cells,y(1,:),'o','color',[255/255,165/255,0] )
plot( x_cells,y(2,:),'s','color',[255/255,165/255,0] )
plot( x_cells,y(3,:),'o','color',[124/255,252/255,0] )
plot( x_cells,y(4,:),'o','color',[1,0,0] )
plot( x_cells,y(5,:),'s','color',[1,0,0] )
plot( x_cells,y(6,:),'d','color',[1,0,0] )
plot( x_cells,y(7,:),'o','color',[0,191/255,1] )
plot( x_cells,y(8,:),'o','color',[0,0,205/255] )
plot( x_cells,y(9,:),'o','color',[160/255,82/255,45/255] )
plot( x_cells,y(10,:),'o','color','k' )
%plot( x_cells,y(11,:),'o','color','k' )

%%%%%%%%%%%%%%
h = zeros(numtot, 1);
h(1) = plot(NaN,NaN,'o-','color',[255/255,165/255,0]);
h(2) = plot(NaN,NaN,'s--','color',[255/255,165/255,0]);
h(3) = plot(NaN,NaN,'o-','color',[124/255,252/255,0]);
h(4) = plot(NaN,NaN,'o-','color',[1,0,0]);
h(5) = plot(NaN,NaN,'s--','color',[1,0,0]);
h(6) = plot(NaN,NaN,'d-.','color',[1,0,0]);
h(7) = plot(NaN,NaN,'o-','color',[0,191/255,1]);
h(8) = plot(NaN,NaN,'o-','color',[0,0,205/255]);
h(9) = plot(NaN,NaN,'o-','color',[160/255,82/255,45/255]);
h(10) = plot(NaN,NaN,'o-','color','k');
%h(11) = plot(NaN,NaN,'o-','color','k');

xlabel('# grid cells')
ylabel('time')

%legend(h, 'BiCGstab + R-S + ILU(l)', 'CG + R-S + ILU(l)', 'BiCGstabl + R-S + ILUT', 'BiCGstabl + R-S + ILU(l)', 'IDR(s) + R-S + ILU(l)', 'mldivide')
legend(h, 'BiCGstab + sm. aggr. + SPAI0', 'BiCGstab + sm. aggr. + G-S', 'CG + sm. aggr. + ILU(0)', 'BiCGstabl + sm. aggr. + ILU(0)', 'BiCGstabl + sm. aggr. + G-S', 'BiCGstabl + R-S + ILU(l)', 'GMRES + sm. aggr. + ILU(0)', 'FGMRES + sm. aggr. + ILU(0)', 'IDR(s) + sm. aggr. + ILU(0)', 'mldivide')

%%%%%%%%%%%%%%

%%%% Solver colors:
% BiCGstab:   [255/255,165/255,0];
% CG:         [124/255,252/255,0];
% BiCGstabl:  [1,0,0];
% GMRES:      [0,191/255,1];
% LGMRES:     [218/255,112/255,214/255];
% FGMRES:     [0,0,205/255];
% IDR(s):     [160/255,82/255,45/255];
%%%%%


